LeetCode 1306. Jump Game III

Question

Given an array of non-negative integers arr, you are initially positioned at start index of the array. When you are at index i, you can jump to i + arr[i] or i - arr[i], check if you can reach to any index with value 0.

Notice that you can not jump outside of the array at any time.

Example 1:

1
2
3
4
5
6
Input: arr = [4,2,3,0,3,1,2], start = 5
Output: true
Explanation:
All possible ways to reach at index 3 with value 0 are:
index 5 -> index 4 -> index 1 -> index 3
index 5 -> index 6 -> index 4 -> index 1 -> index 3

Example 2:

1
2
3
4
5
Input: arr = [4,2,3,0,3,1,2], start = 0
Output: true
Explanation:
One possible way to reach at index 3 with value 0 is:
index 0 -> index 4 -> index 1 -> index 3

Example 3:

1
2
3
Input: arr = [3,0,2,1,2], start = 2
Output: false
Explanation: There is no way to reach at index 1 with value 0.

Constraints:

  • 1 <= arr.length <= 5 * 104
  • 0 <= arr[i] < arr.length
  • 0 <= start < arr.length

Source: https://leetcode.com/problems/jump-game-iii/

Solution

For jump games, if one path reaches a visited point, we can terminate that path (pruning). Because it can be replaced by a previous path.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
// BFS, Time Complexity O(n)
public boolean canReach(int[] arr, int start) {
int len = arr.length;
boolean[] visited = new boolean[len]; // initialized with false
Queue<Integer> queue = new LinkedList<>(); // store indexes
queue.add(start);

while (!queue.isEmpty()) {
int currIndex = queue.poll();
// if current path includes a visited index, it can be replaced
if (visited[currIndex]) {
continue;
}
if (arr[currIndex] == 0) {
return true;
}
visited[currIndex] = true;
if (currIndex + arr[currIndex] < len) {
queue.add(currIndex + arr[currIndex]);
}
if (currIndex - arr[currIndex] >= 0) {
queue.add(currIndex - arr[currIndex]);
}
}
return false;
}

private boolean dfs(int[] arr, boolean[] visited, int start, int len) {
if (start < 0 || start >= len || visited[start]) {
return false;
}
if (arr[start] == 0) {
return true;
}
visited[start] = true;
return dfs(arr, visited, start - arr[start], len) ||
dfs(arr, visited, start + arr[start], len);
}

// DFS, Time Complexity O(n)
public boolean canReach2(int[] arr, int start) {
int len = arr.length;
boolean[] visited = new boolean[len]; // initialized with false
return dfs(arr, visited, start, len);
}
Author

Weihao Ye

Posted on

2022-01-25

Updated on

2022-01-25

Licensed under